'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _coreGetExports = require('../core/getExports');

// not sure if this is needed with Babel?

require('array.prototype.find');

exports['default'] = function (context) {

  function checkDefault(specifierType, node) {
    var defaultSpecifier = node.specifiers.find(function (n) {
      return n.type === specifierType;
    });

    if (!defaultSpecifier) return;
    var imports = (0, _coreGetExports.get)(node.source.value, context);
    if (imports == null) return;

    if (!imports.hasDefault) {
      context.report(defaultSpecifier, 'No default export found in module.');
    }
  }

  return {
    'ImportDeclaration': checkDefault.bind(null, 'ImportDefaultSpecifier'),
    'ExportNamedDeclaration': checkDefault.bind(null, 'ExportDefaultSpecifier')
  };
};

module.exports = exports['default'];